__author__     = "Aaron Straup Cope"
__url__        = "http://aaronland.info/python/w5"
__version__    = "1.0a1"
__cvsversion__ = "$Revision: 1.9 $"
__date__       = "$Date: 2004/05/03 11:53:39 $"
__copyright__  = "%s\n%s\n%s" % \
                 ("This application is licensed under the",
                  "Creative Commons Attribution-NonCommercial License",
                  "http://creativecommons.org/licenses/by-nc/1.0/")

__license__    = "This application is licensed under the Creative \
Commons Attribution-NonCommercial License. To view a copy of this \
license, visit http://creativecommons.org/licenses/by-nc/1.0/ or send \
a letter to Creative Commons, 559 Nathan Abbott Way, Stanford, \
California 94305, USA."

# $Id: rEdit.py,v 1.9 2004/05/03 11:53:39 asc Exp $

from wxPython.wx import *

ID_ENDPOINT  = wxNewId()
ID_TITLE     = wxNewId()
ID_LOGIN     = wxNewId()
ID_FILTER    = wxNewId()
ID_OK        = wxNewId()
ID_CANCEL    = wxNewId()

class rEdit (wxFrame) :

    def __init__ (self,parent,style,cfg,endpoint=None):

        self.__cfg__     = cfg
        self.__service__ = None
        self.__input__   = {"endpoint":None,"title":None,
                            "login":None,"filter":None}
        
        #
        
        if endpoint != None:
            self.__service__ = self.__cfg__.DescribeService(endpoint)
            title    = "Edit %s " % (self.__service__.Title())            
        else:        
            title = "Add a new service"

        #
        
        wxFrame.__init__(self,parent,style,title)
        (min_x,min_y) = self.GetBestSize()

        #

        # fs = self.GetFont().GetPointSize()
        # bf = wxFont(fs, wxSWISS, wxNORMAL, wxBOLD)

        #
        
        ctrl_endpoint = wxTextCtrl(self,ID_ENDPOINT,
                                   size = (min_x,-1))

        ctrl_title = wxTextCtrl(self,ID_TITLE,
                                size = (min_x,-1))    

        ctrl_login = wxTextCtrl(self,ID_LOGIN,
                                size = (min_x,-1))    
        
        ctrl_filter = wxCheckBox(self,ID_FILTER,
                                 "enable filter")
                
        #

        spacer = wxSize(5,5)
        
        sz_required = wxStaticBoxSizer(wxStaticBox(self,-1,"required"),
                                       wxVERTICAL)

        sz_required.Add(spacer)
	sz_required.Add(wxStaticText(self,-1,"endpoint"),
			0,wxALIGN_RIGHT)
        sz_required.Add(ctrl_endpoint)
        
        #

        sz_optional = wxStaticBoxSizer(wxStaticBox(self,-1,"optional"),
                                          wxVERTICAL)
        sz_optional.Add(spacer)

	sz_optional.Add(wxStaticText(self,-1,"title"),
                        0,wxALIGN_RIGHT)
        sz_optional.Add(ctrl_title)
        sz_optional.Add(spacer)

	sz_optional.Add(wxStaticText(self,-1,"login"),
                        0,wxALIGN_RIGHT)        
        sz_optional.Add(ctrl_login)
        sz_optional.Add(spacer)

        sz_optional.Add(ctrl_filter)
                
        sz_control  = wxBoxSizer(wxHORIZONTAL)
        
        sz_control.Add(wxButton(self,ID_OK,"OK"))
        sz_control.Add(spacer)
        sz_control.Add(wxButton(self,ID_CANCEL,"Cancel"))
        
        #

        sz_body = wxBoxSizer(wxVERTICAL)         

        sz_body.Add(sz_required)
        sz_body.Add(spacer)        
        sz_body.Add(sz_optional)

        sz_body.Add(spacer)
        sz_body.Add(spacer)
        
        sz_body.Add(sz_control,0,wxALIGN_RIGHT)

        sz_padding = wxBoxSizer(wxHORIZONTAL)
        sz_padding.Add(spacer)
        sz_padding.Add(sz_body)
        sz_padding.Add(spacer)

        sz_main = wxBoxSizer(wxVERTICAL)
        sz_main.Add(spacer)
        sz_main.Add(sz_padding)
        sz_main.Add(spacer)
        
        # someone please explain to me why this is
        # better than : if (my $foo = $self->{foo})
    
        if  self.__service__ != None:

            self.__input__["endpoint"] = self.__service__.Endpoint()
            ctrl_endpoint.SetValue(self.__input__["endpoint"])

            if self.__service__.Title() != None and \
               self.__service__.Title() != self.__service__.Endpoint() :

                self.__input__["title"] = self.__service__.Title()
                ctrl_title.SetValue(self.__input__["title"])

            if self.__service__.Login() != None:
                self.__input__["login"] = self.__service__.Login()
                ctrl_login.SetValue(self.__input__["login"])
                
            if self.__service__.Filter() != None:

                self.__input__["filter"] = 1
                ctrl_filter.SetValue(self.__input__["filter"])
        
        #
        
	self.SetSizer(sz_main)
        self.SetAutoLayout(1)        

        self.CreateStatusBar()
        sz_main.Fit(self)

        EVT_BUTTON(self, ID_OK, self.OK)
        EVT_BUTTON(self, ID_CANCEL, self.Cancel)

        EVT_TEXT(self,ID_ENDPOINT, self.__endpoint)
        EVT_TEXT(self,ID_LOGIN, self.__login)
        EVT_TEXT(self,ID_TITLE, self.__title)

        EVT_CHECKBOX(self,ID_FILTER, self.__filter)
        
        # Need to make sure to add TAB support...

    def __endpoint (self,event):
        self.__input__["endpoint"] = event.GetString()

    def __login (self,event):
        self.__input__["login"] = event.GetString()

    def __title (self,event):
        self.__input__["title"] = event.GetString()

    def __filter (self,event):
        self.__input__["filter"] = event.IsChecked()
        
    def OK (self,event):

        if self.__input__["endpoint"] == None:
            self.Error("You must supply an endpoint.")
            return false
        
        #

        if self.__service__ == None :
            self.__cfg__.AddService(self.__input__)
        else :
            self.__cfg__.SetService(self.__input__)

        #
        
	self.__cfg__.Write()

        # YA hack -- I need to figure out how to
        # get this to be called automagically in
        # rPrefs.py when the rEdit frame is destroyed
        
        self.GetParent().LoadServices()
	self.Destroy()

    def Cancel(self,event):
        self.Destroy()

    def Error (self,msg) :
        dlg = wxMessageDialog(self,
                              msg,
                              "Error",
			      wxOK | wxICON_INFORMATION)
        dlg.ShowModal()
        dlg.Destroy()
