__author__     = "Aaron Straup Cope"
__url__        = "http://aaronland.info/python/w5"
__version__    = "1.0a1"
__cvsversion__ = "$Revision: 1.12 $"
__date__       = "$Date: 2004/05/03 11:53:39 $"
__copyright__  = "%s\n%s\n%s" % \
                 ("This application is licensed under the",
                  "Creative Commons Attribution-NonCommercial License",
                  "http://creativecommons.org/licenses/by-nc/1.0/")

__license__    = "This application is licensed under the Creative \
Commons Attribution-NonCommercial License. To view a copy of this \
license, visit http://creativecommons.org/licenses/by-nc/1.0/ or send \
a letter to Creative Commons, 559 Nathan Abbott Way, Stanford, \
California 94305, USA."

# $Id: rPrefs.py,v 1.12 2004/05/03 11:53:39 asc Exp $

from wxPython.wx import *
from rEdit       import rEdit

ID_PREFSBOX     = wxNewId()
ID_SERVICELIST  = wxNewId()
ID_ADDBUTTON    = wxNewId()
ID_EDITBUTTON   = wxNewId()
ID_REMOVEBUTTON = wxNewId()
ID_IMPORTBUTTON = wxNewId()
ID_CLOSEBUTTON  = wxNewId()

class rPrefs (wxFrame) :

    def __init__ (self,parent,style,cfg):
        wxFrame.__init__(self,parent,style,"Services")

        self.__cfg__ = cfg    

        self.list = wxListBox(self, ID_SERVICELIST,
                            (0,0), (-1,-1),
                            [], wxLB_SINGLE)

        self.LoadServices()

        #
                
        self.bt_add    = wxButton(self,ID_ADDBUTTON,"Add")
        self.bt_edit   = wxButton(self,ID_EDITBUTTON,"Edit")
        self.bt_remove = wxButton(self,ID_REMOVEBUTTON,"Remove")

        self.bt_close  = wxButton(self,ID_CLOSEBUTTON,"Close")
        
        self.bt_edit.Enable(false)
        self.bt_remove.Enable(false)
        
        #

        spacer = wxSize(5,5)
        
	sz_services = wxBoxSizer(wxHORIZONTAL)

        sz_buttons = wxBoxSizer(wxVERTICAL)
        
        sz_buttons.Add(self.bt_add)
        sz_buttons.Add(self.bt_edit)
        sz_buttons.Add(self.bt_remove)
        
        sz_close = wxBoxSizer(wxHORIZONTAL)
        sz_close.Add(self.bt_close)
        
        sz_services.Add(self.list,1,wxEXPAND)
        sz_services.Add(spacer)
        sz_services.Add(sz_buttons)
 
        sz_body = wxBoxSizer(wxVERTICAL)

        sz_body.Add(sz_services)
        sz_body.Add(spacer)        
        sz_body.Add(wxStaticLine(self,-1),0,wxEXPAND)
        sz_body.Add(spacer)
        sz_body.Add(spacer)
        sz_body.Add(sz_close,0,wxALIGN_RIGHT)

	sz_padx = wxBoxSizer(wxHORIZONTAL)
	sz_padx.Add(spacer)
	sz_padx.Add(sz_body)
	sz_padx.Add(spacer)

	sz_main = wxBoxSizer(wxVERTICAL)
	sz_main.Add(spacer)
	sz_main.Add(sz_padx)
	sz_main.Add(spacer)
	
	self.SetSizer(sz_main)
        self.SetAutoLayout(1)

        self.CreateStatusBar()
        sz_main.Fit(self)
        
	#

        EVT_BUTTON(self, ID_ADDBUTTON,    self.Add)
        EVT_BUTTON(self, ID_EDITBUTTON,   self.Edit)
        EVT_BUTTON(self, ID_REMOVEBUTTON, self.Remove)
        EVT_BUTTON(self, ID_CLOSEBUTTON,  self.Close)

	EVT_KEY_DOWN(self,self.KeyDown)
                
        EVT_LISTBOX(self, ID_SERVICELIST, self.EvtListBox)
        EVT_LISTBOX_DCLICK(self, ID_SERVICELIST, self.EvtListBoxDClick)

    def KeyDown(self,event):
        
	print "keycode %s" % keycode
	print "keyname %s" % chr(keycode)

	if event.ControlDown():
            keycode = event.GetKeyCode()
        else:
            event.Skip()
            return true
        
        if keycode <= 256:
            keyname = chr(keycode)
        else:
            event.Skip()
            return true
        
	if keyname == "A":
            self.Add(event)
        elif keyname == "E":
            self.Edit(event)
        elif keyname == "R":
            self.Remove(event)
        elif keyname == "W":
            self.Close(event)
        else:
            event.Skip()
	
	return true

    def EvtListBox (self,event):
        self.bt_edit.Enable(true)
        self.bt_remove.Enable(true)
        
        self.__selected__ = event.GetSelection()
        
    def EvtListBoxDClick (self,event):
        self.__selected__ = event.GetSelection()
        self.Edit(event)

    def LoadServices (self) :

        self.__cfg__.Load()
        
        self.__titles__    = []
        self.__endpoints__ = []
        
        for s in self.__cfg__.ListServices():

            endpoint = self.__cfg__.DescribeService(s).Endpoint()
            title    = self.__cfg__.DescribeService(s).Title()

            # sort me...
            
            self.__titles__.append(title)            
            self.__endpoints__.append(endpoint)

        self.list.Set(self.__titles__)
        
    def Add(self,event):

	(x,y) = self.GetPosition()
        
        edit = rEdit(self,-1,self.__cfg__)
	edit.SetPosition((x - 25,y + 50))
        edit.Show()
        
    def Edit(self,event):

        endpoint = self.__endpoints__[ self.__selected__ ]

        edit = rEdit(self,-1,self.__cfg__,endpoint)
        edit.Show()

    def Remove(self,event):

        endpoint = self.__endpoints__[ self.__selected__ ]
        self.__cfg__.RemoveService(endpoint)

        self.LoadServices()
        
    def Close(self,event):
        self.Destroy()

        
