__author__     = "Aaron Straup Cope"
__url__        = "http://aaronland.info/python/w5"
__version__    = "1.0a1"
__cvsversion__ = "$Revision: 1.8 $"
__date__       = "$Date: 2004/05/03 11:53:39 $"
__copyright__  = "%s\n%s\n%s" % \
                 ("This application is licensed under the",
                  "Creative Commons Attribution-NonCommercial License",
                  "http://creativecommons.org/licenses/by-nc/1.0/")

__license__    = "This application is licensed under the Creative \
Commons Attribution-NonCommercial License. To view a copy of this \
license, visit http://creativecommons.org/licenses/by-nc/1.0/ or send \
a letter to Creative Commons, 559 Nathan Abbott Way, Stanford, \
California 94305, USA."

# $Id: rService.py,v 1.8 2004/05/03 11:53:39 asc Exp $

from rdflib.Namespace import Namespace
from rConstants import NS_W5, NS_DUBLINCORE

class rService:

    def __init__ (self,service,attrs={}) :

        self.__endpoint__ = service
        self.__attrs__    = attrs

        self.__ns__       = {}
        self.__ns__["w5"] = Namespace(NS_W5)
        self.__ns__["dc"] = Namespace(NS_DUBLINCORE)
    
    def Endpoint (self) :
        return self.__endpoint__

    def Title (self) :

        title = self.__ns__["dc"]["title"]
        
        if self.__attrs__.has_key(title):
            return self.__attrs__[title]
        else :
            return self.Endpoint()
        
    def Login (self) :
        return self.__w5__("login")

    def Filter (self) :
        return self.__w5__("filter")

    def __w5__ (self,attr) :

        attr = self.__ns__["w5"][attr]
        
        if self.__attrs__.has_key(attr):
            return self.__attrs__[attr]
        else :
            self.__attrs__[attr] = None
            return None
    
